//+======================================================================
// $Source: /segfs/tango/tools/pogo/appli/RCS/PogoAppliDefs.java,v $
//
// Project:   Tango
//
// Description:  java source code for the Pogo class definition .
//
// $Author: verdier $
//
// $Version$
//
// $Log: PogoAppliDefs.java,v $
// Revision 1.24  2001/04/04 12:22:58  verdier
// Property management added for cpp.
//
// Revision 1.23  2000/10/24 06:21:22  verdier
// The compatibility with TANGO2 has been tested on DatabaseDs.
//
// Revision 1.22  2000/10/02 05:52:20  verdier
// Attribute code generated is now compatible with Tango 2.
//
// Revision 1.21  2000/09/22 08:54:31  verdier
// DevState & DevStatus are virtual.
// First tests with Tango2
// Taco import utility added.
//
// Revision 1.20  2000/07/07 13:30:10  verdier
// Utilities added after first users.
//
// Revision 1.18  2000/06/20 06:57:35  verdier
// Right button double click management added for :
// editing src code, creating item, editing class....
// Little bugs fixed on generation/re-read src code.
//
// Revision 1.17  2000/05/12 07:37:10  verdier
//  Attributes management added for java generation.
//
// Revision 1.16  2000/04/26 06:04:00  verdier
// The save/restore file (.pogo) does not exist anymore.
// DevStates and DevStates allowed management is now available for java.
//
// Revision 1.15  2000/04/18 08:12:47  verdier
// Management of DevStates to allow command added.
//
// Revision 1.14  2000/04/12 09:25:43  verdier
// Methods to manage attributes are now generated
//  Only if at leat one attribute exists.
//
// Revision 1.13  2000/04/11 09:35:07  verdier
// Attributes management added.
//
// Revision 1.3  2000/03/29 13:11:48  verdier
// Doc generation added.
//
// Revision 1.2  2000/03/03 09:43:00  verdier
// States management added
//
// Revision 1.1  2000/02/28 15:41:38  verdier
// Initial revision
//
//
// Copyright 1995 by European Synchrotron Radiation Facility, Grenoble, France
//               All Rights Reversed
//-======================================================================

package pogo.appli;



public interface PogoAppliDefs 
{
	public final int	BTN1 = 0;
	public final int	BTN2 = 1;
	public final int	BTN3 = 2;

	public final int	CLASS_PROPERTIES = 0;
	public final int	DEV_PROPERTIES   = 1;
	public final int	COMMANDS         = 2;
	public final int	ATTRIBUTES       = 3;
	public final int	STATES           = 4;

	public final int	TREE_ROOT  = 0;
	public final int	COLLECTION = 1;
	public final int	LEAF_ITEM  = 2;

	public final int	RET_ERROR  = -1;
	public final int	RET_CANCEL = 0;
	public final int	RET_OK = 1;
	
	public final int	OPEN_FILE = 0;
	public final int	IMPORT_FILE = 1;
	
	public final int	FILE_SAVE = 0;
	public final int	GENE_SRC = 1;
	public final int	GENE_DOC = 2;

	public final int	PALETTE_EDIT_CLASS        = 0;
	public final int	PALETTE_CREATE_CLASS_PROP = 2;
	public final int	PALETTE_CREATE_DEV_PROP   = 3;
	public final int	PALETTE_CREATE_CMD        = 4;
	public final int	PALETTE_CREATE_ATTR       = 5;
	public final int	PALETTE_CREATE_STATE      = 6;

	public static String[]	TangoTypesArray = {
			"Tango::DEV_VOID",
			"Tango::DEV_BOOLEAN",
			"Tango::DEV_SHORT",
			"Tango::DEV_LONG",
			"Tango::DEV_FLOAT",
			"Tango::DEV_DOUBLE",
			"Tango::DEV_USHORT",
			"Tango::DEV_ULONG",
			"Tango::CONST_DEV_STRING",
			"Tango::DEV_STRING",

			"Tango::DEVVAR_CHARARRAY",
			"Tango::DEVVAR_SHORTARRAY",
			"Tango::DEVVAR_LONGARRAY",
			"Tango::DEVVAR_FLOATARRAY",
			"Tango::DEVVAR_DOUBLEARRAY",
			"Tango::DEVVAR_USHORTARRAY",
			"Tango::DEVVAR_ULONGARRAY",
			"Tango::DEVVAR_STRINGARRAY",
			"Tango::DEVVAR_LONGSTRINGARRAY",
			"Tango::DEVVAR_DOUBLESTRINGARRAY",
			"Tango::DEV_STATE"
		};

	public static String[]	TangoPropertyTypesArray = {
			"Tango::DEV_BOOLEAN",
			"Tango::DEV_SHORT",
			"Tango::DEV_LONG",
			"Tango::DEV_FLOAT",
			"Tango::DEV_DOUBLE",
			"Tango::DEV_USHORT",
			"Tango::DEV_ULONG",
			"Tango::CONST_DEV_STRING",
			"string",
			
			"Array of short",
			"Array of long",
			"Array of float",
			"Array of double",
			"Array of string",
		};

	public String	helpContents ="This help utility is not yet implemented\n\nIt will come later. Soon, may be....";
	public String	helpAbout    = "This is the famous POGO application.\nThe Program Obviously used to Generate tango Object.";


}
